#include "entscheidung.h"
#include "referee.h"
#include <math.h>
#include <stdlib.h>
#include "Configuration.h"

Punkt Brain::ComputePosBesideBall (Punkt pos_ball, double distance, Punkt pos_self)
{
Vektor pref_direction;
Punkt target1, target2;
double dist1, dist2;

  pref_direction = m_cAdvSkills->ComputeBestWatchDirection (m_cWeltmodell->frage_selbst ().frage_p ());
  pref_direction = (distance/pref_direction.norm ()) * pref_direction;

  pref_direction.drehen (PI/2.0);
  target1 = pos_ball + pref_direction;
  dist1 = (target1-pos_self).norm ();
  pref_direction.drehen (PI);
  target2 = pos_ball + pref_direction;
  dist2 = (target2-pos_self).norm ();
  
#ifdef DEBUG
  cout << "Self.x1 " << pos_self.x1 << " x2 " << pos_self.x2 << endl;
  cout << "Ball.x1 " << pos_ball.x1 << " x2 " << pos_ball.x2 << endl;
  cout << "Ziel1.x1 " << target1.x1 << " x2 " << target1.x2 << endl;
  cout << "Ziel2.x1 " << target2.x1 << " x2 " << target2.x2 << endl;
#endif
  
  if (dist1 <= dist2)
    return target1;
  else
    return target2;
}

int Brain::ComputeBestActiveBehaviour (double bestkickvalue)
{
double prob;

  prob = ((double) rand ())/(RAND_MAX+1.0);

  if (prob <= m_fDribbleFactor * exp (-((bestkickvalue-m_fAcceptance)*(bestkickvalue-m_fAcceptance)/3.38)))
    return DO_DRIBBLE;
  else
    if (bestkickvalue < m_fAcceptance)
      return DO_KICK;
    else
      return DO_GOALKICK;
}

int Brain::WhichDirection ()
{
  if (m_nNextLeftDirection < 0 && m_nNextRightDirection >= 2*DIRECTION_FRONT)
    return NO_DIRECTION_LEFT;
  if (m_nNextLeftDirection <= 0 && m_nNextRightDirection > 2*DIRECTION_FRONT)
    return NO_DIRECTION_LEFT;
  if (m_nNextLeftDirection < 0)
    return RIGHT_DIRECTION;
  if (m_nNextRightDirection > 2*DIRECTION_FRONT)
    return LEFT_DIRECTION;

Koerper y_self;
char side;
double prob;

  y_self = m_cWeltmodell->frage_selbst ().frage_p ().x2;
  side = m_cWeltmodell->frage_seite ();
  prob = ((double) rand ())/(RAND_MAX+1.0);

  // ueberfluessige Drehungen vermeiden
  if (m_nRegion == REGION_IX)
    if (side == linke_seite)
      if (m_nNextLeftDirection >= DIRECTION_FRONT-1)
        return LEFT_DIRECTION;
      else
        return NO_DIRECTION_LEFT;
    else
      if (m_nNextRightDirection <= DIRECTION_FRONT+1)
        return RIGHT_DIRECTION;
      else
        return NO_DIRECTION_LEFT;
  if (m_nRegion == REGION_VII)
    if (side == linke_seite)
      if (m_nNextRightDirection <= DIRECTION_FRONT+1)
        return RIGHT_DIRECTION;
      else
        return NO_DIRECTION_LEFT;
    else
      if (m_nNextLeftDirection >= DIRECTION_FRONT-1)
        return LEFT_DIRECTION;
      else
        return NO_DIRECTION_LEFT;
        
  if (m_nRegion == REGION_V || m_nRegion == REGION_X || m_nRegion == REGION_VIII || m_nRegion == REGION_IV)
    if (m_nNextLeftDirection < DIRECTION_FRONT-1 && m_nNextRightDirection > DIRECTION_FRONT+1)
      return NO_DIRECTION_LEFT;

  if (y_self > 0)
    if (side == linke_seite)
      if (prob <= 0.5*y_self/34.0 + 0.5)
        return RIGHT_DIRECTION;
      else
        return LEFT_DIRECTION;
    else
      if (prob <= 0.5*y_self/34.0 + 0.5)
        return LEFT_DIRECTION;
      else
        return RIGHT_DIRECTION;
  else
    if (side == linke_seite)
      if (prob <= 0.5*(-y_self)/34.0 + 0.5)
        return LEFT_DIRECTION;
      else
        return RIGHT_DIRECTION;
    else
      if (prob <= 0.5*(-y_self)/34.0 + 0.5)
        return RIGHT_DIRECTION;
      else
        return LEFT_DIRECTION;
}

int Brain::ComputeNextWatchDirection (Koerper* nextdegree)
{
Vektor direction;
Punkt pos_dir, pos_self;
Relative_Koordinate rel_pos_dir;

#ifdef DEBUG
  cout << endl << "Bestimmung des naechsten Blickwinkels: " << endl;
#endif
  pos_self = m_cWeltmodell->frage_selbst ().frage_p ();
  switch (WhichDirection ())
  {
    case LEFT_DIRECTION:
      if (m_nNextLeftDirection == DIRECTION_FRONT)
      {
        direction = m_cAdvSkills->ComputeBestWatchDirection (pos_self);
        m_cBestWatchDirection = direction;

        // Relativumwandlung von direction
        pos_dir.x1 = pos_self.x1 + direction.x1;
        pos_dir.x2 = pos_self.x2 + direction.x2;
        m_cWeltmodell->berechne_relativ (rel_pos_dir, pos_dir);
        *nextdegree = rad_in_deg (rel_pos_dir.richtung); 
#ifdef DEBUG
        cout << "    Vorzugsrichtung (relativ in Grad): " << endl;
        cout << "       " << *nextdegree << endl;
#endif        
        m_nNextLeftDirection--;
        if (m_nNextRightDirection == DIRECTION_FRONT)
          m_nNextRightDirection++;
      }
      else
      {
        direction = m_cBestWatchDirection;
        direction.drehen (((double)(DIRECTION_FRONT - m_nNextLeftDirection)) * (PI/((double)DIRECTION_FRONT)));
        // Relativumwandlung von direction
        pos_dir.x1 = pos_self.x1 + direction.x1;
        pos_dir.x2 = pos_self.x2 + direction.x2;
        m_cWeltmodell->berechne_relativ (rel_pos_dir, pos_dir);
        *nextdegree = rad_in_deg (rel_pos_dir.richtung); 
#ifdef DEBUG
        cout << "     Linksdrehung (relativ): " << endl;
        cout << "        " << *nextdegree << endl;
#endif        
        m_nNextLeftDirection--;
      }
      return 1;
    case RIGHT_DIRECTION:
      if (m_nNextRightDirection == DIRECTION_FRONT)
      {
        direction = m_cAdvSkills->ComputeBestWatchDirection (pos_self);
        m_cBestWatchDirection = direction;

        // Relativumwandlung von direction
        pos_dir.x1 = pos_self.x1 + direction.x1;
        pos_dir.x2 = pos_self.x2 + direction.x2;
        m_cWeltmodell->berechne_relativ (rel_pos_dir, pos_dir);
        *nextdegree = rad_in_deg (rel_pos_dir.richtung); 
#ifdef DEBUG
        cout << "    Vorzugsrichtung (relativ in Grad): " << endl;
        cout << "       " << *nextdegree << endl;
#endif
        m_nNextRightDirection++;
        if (m_nNextLeftDirection == DIRECTION_FRONT)
          m_nNextLeftDirection--;
      }
      else
      { 
        direction = m_cBestWatchDirection;
        direction.drehen (((double)(m_nNextRightDirection - DIRECTION_FRONT)) * (-PI/((double)DIRECTION_FRONT)));
        // Relativumwandlung von direction
        pos_dir.x1 = pos_self.x1 + direction.x1;
        pos_dir.x2 = pos_self.x2 + direction.x2;
        m_cWeltmodell->berechne_relativ (rel_pos_dir, pos_dir);
        *nextdegree = rad_in_deg (rel_pos_dir.richtung); 
#ifdef DEBUG
        cout << "     Linksdrehung (relativ): " << endl;
        cout << "        " << *nextdegree << endl;
#endif        
        m_nNextRightDirection++;
      } 
      return 1;
    case NO_DIRECTION_LEFT:
      return 0;
  }
}

Koerper min (Koerper a, Koerper b)
{
  if (b<a)
    return b;
  else
    return a;
}

Koerper max (Koerper a, Koerper b)
{
  if (b>a)
    return b;
  else
    return a;
}

Koerper RoundTo10 (Koerper a)
{
  return (rint (a/10.0) * 10.0);
}

int Brain::ComputeAllowedKickDegrees (Koerper* leftdegree, Koerper* rightdegree)
{
Koerper y_self;
Vektor direction;
Koerper alpha;
double delta;
  
  // Standardfall
  *leftdegree = -40.0;
  *rightdegree = 40.0;
  y_self = m_cWeltmodell->frage_selbst ().frage_p ().x2;
  if (y_self >= AREA_U_2 && y_self <= AREA_O_2)
    return 1;
    
  // Nichtstandardfaelle, Berechnung noetig
  direction = m_cWeltmodell->frage_selbst ().frage_richtung ();
  alpha = rad_in_deg (acos (direction.x1/direction.norm ()));
  if (alpha>90.0)
    alpha = 180.0 - alpha;
  
  // untere Linie
  if (y_self < AREA_U_2)
  {
    // Toleranz einrechnen?
    if (y_self > AREA_U_1)
      delta = (y_self - AREA_U_1)/(AREA_U_2 - AREA_U_1);
    else
      delta = 0.0;
    
    if (alpha > 40.0 && direction.x2 < 0)
      return 0;
    if (direction.x1 > 0)
      if (direction.x2 > 0)
        *rightdegree = min (40.0, alpha + delta*MAX_DEGREE_DERIVATION);
      else
        *rightdegree = max (-40.0, -alpha + delta*MAX_DEGREE_DERIVATION);
    else
      if (direction.x2 > 0)
        *leftdegree = max (-40.0, -alpha - delta*MAX_DEGREE_DERIVATION);
      else  
        *leftdegree = min (40.0, alpha - delta*MAX_DEGREE_DERIVATION);
  }
  
  // obere Linie
  if (y_self > AREA_O_2)
  {
    // Toleranz einrechnen?
    if (y_self < AREA_O_1)
      delta = (AREA_O_1 - y_self)/(AREA_O_1 - AREA_O_2);
    else
      delta = 0.0;
  
    if (alpha > 40.0 && direction.x2 > 0)
      return 0;
    if (direction.x1 > 0)
      if (direction.x2 > 0)
        *leftdegree = min (40.0, alpha - delta*MAX_DEGREE_DERIVATION);
      else
        *leftdegree = max (-40.0, -alpha - delta*MAX_DEGREE_DERIVATION);
    else
      if (direction.x2 > 0)
        *rightdegree = max (-40.0, -alpha + delta*MAX_DEGREE_DERIVATION);
      else
        *rightdegree = min (40.0, alpha + delta*MAX_DEGREE_DERIVATION);
  }
  *leftdegree = RoundTo10 (*leftdegree);
  *rightdegree = RoundTo10 (*rightdegree);
  return 1;
}

double Brain::ComputeBestKickDirection (Koerper* bestdegree, Koerper* bestpower)
{
// Variablen fuer die Richtungswertung
int seen_players;
double distance, range, distance_sum;
double our_best_distance, their_best_distance;
double our_mean_distance, their_mean_distance;
int direction_jammed;

// Variablen fuer die globale Minimierung
double global_distance, global_best_distance, global_best_goal_derivation, global_best_power;
Koerper global_best_degree;

// Handhabung der Distanzfunktion BestWay2Ball
Spieler_Selbst dummy_player;
Ball dummy_ball;
double dummy_turn, dummy_kick;
Vektor kick_direction;
Vektor player_direction;
Relative_Koordinate rel_pos_player;
double stamina;

// Schleifenvariablen
Koerper left_degree, right_degree;
Koerper degree;
int player_number;

// Variablen fuer den Torbonus bzw. Tormalus
double y_cut, x_self, y_self, x_goal;
Relative_Koordinate rel_pos_their_goal, rel_pos_our_goal;
double goal_bonus, goal_malus;
int goal_kick_free;

  // Initialisierung der besten Werte
  global_best_distance = WORST_DISTANCE;
  global_best_degree = 0.0;
  global_best_goal_derivation = 180;
  global_best_power = m_fKickPower;
    
  // Outer Loop fuehrt durch die diskreten Winkel um die Sichtachse
#ifdef DEBUG
  cout << endl << "Bestimmung der besten Kickrichtung: " << endl;  
#endif
  if (!ComputeAllowedKickDegrees (&left_degree, &right_degree))
  {
    *bestdegree = global_best_degree;
    return WORST_DISTANCE;
  }

  for (degree=left_degree; degree<=right_degree; degree+=10.0)
  {
    dummy_ball = m_cWeltmodell->frage_ball ();
    kick_direction = m_cWeltmodell->frage_selbst ().frage_richtung();
    kick_direction.drehen (-deg_in_rad(degree));
    dummy_ball.setze_v ((m_fKickPower*globalConf->kickPowerRate)*kick_direction);

    goal_kick_free = 1;
    direction_jammed = 0;
    //Inner Loop fuehrt durch die eigenen sichtbaren Spieler
    our_best_distance = WORST_DISTANCE;
    distance_sum = 0.0;
    seen_players = 0;
    for (player_number=0; player_number<=9; player_number++)
    {
      dummy_player = ((Spieler_Selbst&) m_cWeltmodell->frage_spieler (player_number, team_wir));
      m_cWeltmodell->berechne_relativ (rel_pos_player, dummy_player.frage_p ());
      if (fabs(rad_in_deg(rel_pos_player.richtung))>globalConf->kickDirIgnoreOurPlayerDir){
	continue;
      }      
      if (rel_pos_player.d > globalConf->kickDirIgnoreOurPlayerDist){
	continue;
      }
      if(fabs(rad_in_deg(rel_pos_player.richtung) - degree) < 10 && 
        dummy_player.frage_p().x1 < m_cWeltmodell->frage_aktuelle_situation()->offsideLineX()){
        degree+=10;
        direction_jammed = 1;
        break; // Spieler steht im Abseits        
      }
      if (dummy_player.frage_wert () < 3)
      {
        seen_players ++;
        player_direction.x1 = 1.0;
        player_direction.x2 = 0.0;
        dummy_player.setze_richtung (player_direction);
        range = fabs (rel_pos_player.d * sin (fabs (rel_pos_player.richtung - deg_in_rad (degree))));
        if (range < BALL_RADIUS)
        {
          goal_kick_free = 0;
          if (rel_pos_player.d < JAMM_RANGE)
          {
            direction_jammed = 1;
            break; // diese Richtung ist versperrt, also naechsten Winkel ausprobieren
          }
        }
        range = range * 0.66 + 1;
		
        // BestWay2Ball = -1 abfangen
        distance = ((double) m_cAdvSkills->BestWay2Ball (dummy_ball, dummy_player, &dummy_turn, &dummy_kick, &stamina));
        if (distance == -1.0)
          distance = WORST_DISTANCE;
        else
          distance = sqrt (distance * range);
#ifdef DEBUG
        cout << "      Distanz: " << distance << endl;
#endif
        if (distance < our_best_distance)
          our_best_distance = distance;
        distance_sum += distance;
      }
    }
    our_mean_distance = (WORST_DISTANCE * (NUMBER_OF_OUR_PLAYERS - ((double)seen_players)) + distance_sum)/
                        NUMBER_OF_OUR_PLAYERS;
        
    if (direction_jammed)
      continue;
        
    //Inner Loop fuehrt durch die fremden sichtbaren Spieler
    their_best_distance = WORST_DISTANCE;
    distance_sum = 0.0;
    seen_players = 0;   
    for (player_number=0; player_number<=10; player_number++)
    {
      dummy_player = ((Spieler_Selbst&) m_cWeltmodell->frage_spieler (player_number, team_sie));
      m_cWeltmodell->berechne_relativ (rel_pos_player, dummy_player.frage_p ());
      if (fabs(rad_in_deg(rel_pos_player.richtung))>globalConf->kickDirIgnoreTheirPlayerDir){
	continue;
      }
     
      if (rel_pos_player.d>globalConf->kickDirIgnoreTheirPlayerDist){
	continue;
      }
      
      if (dummy_player.frage_wert () < 3)
      {
        seen_players++;
        player_direction.x1 = 1.0;
        player_direction.x2 = 0.0;
        dummy_player.setze_richtung (player_direction);
        range = fabs (rel_pos_player.d * sin (fabs (rel_pos_player.richtung - deg_in_rad(degree))));
        if (range < BALL_RADIUS)
        {
          goal_kick_free = 0;
          if (rel_pos_player.d < JAMM_RANGE)
          {
            direction_jammed = 1;
            break; // diese Richtung ist versperrt, also naechsten Winkel ausprobieren
          }
        }
        range = range * 0.66 + 1;
        // BestWay2Ball = -1 abfangen
        distance = ((double) m_cAdvSkills->BestWay2Ball (dummy_ball, dummy_player, &dummy_turn, &dummy_kick, &stamina));
        if (distance == -1.0)
          distance = WORST_DISTANCE;
        else
          distance = sqrt (distance * range);
#ifdef DEBUG
        cout << "      Distanz: " << distance << endl;
#endif
        if (distance < their_best_distance)
          their_best_distance = distance;
        distance_sum += distance;
      }
    }
    their_mean_distance = (WORST_DISTANCE * (NUMBER_OF_THEIR_PLAYERS - ((double)seen_players)) + distance_sum)/
                          NUMBER_OF_THEIR_PLAYERS;
                              
    if (direction_jammed)
      continue;

    // Torbonus bestimmen
    goal_bonus = 0.0;
    m_cWeltmodell->berechne_relativ (rel_pos_their_goal, m_cWeltmodell->frage_ihr_tor ().p);
    if (goal_kick_free)
    {
      x_self = m_cWeltmodell->frage_selbst ().frage_p ().x1;
      y_self = m_cWeltmodell->frage_selbst ().frage_p ().x2;
      x_goal = m_cWeltmodell->frage_ihr_tor ().p.x1;
      if ((kick_direction.x1 > 0 && x_goal > 0) || (kick_direction.x1 < 0 && x_goal < 0))
      {
        y_cut = y_self + ((x_goal - x_self)/kick_direction.x1) * kick_direction.x2;
        if (fabs (y_cut) < (GOAL_WIDTH/2.0 - 4.0 - BALL_RADIUS))
        {
          goal_bonus = (-WORST_DISTANCE/BALL_KICK_RANGE) * rel_pos_their_goal.d + WORST_DISTANCE;
          if (goal_bonus < 0.0)
            goal_bonus = 0.0;
        }
      }           
    }

    // Tormalus bestimmen
    goal_malus = 0.0;
    m_cWeltmodell->berechne_relativ (rel_pos_our_goal, m_cWeltmodell->frage_unser_tor ().p);
    x_goal = m_cWeltmodell->frage_unser_tor ().p.x1;
    if ((kick_direction.x1 > 0 && x_goal > 0) || (kick_direction.x1 < 0 && x_goal < 0))
    {
      y_cut = y_self + ((x_goal - x_self)/kick_direction.x1) * kick_direction.x2;
      if (fabs (y_cut) < (GOAL_WIDTH/2.0 + 4.0))
      {
        goal_malus = (-WORST_DISTANCE/BALL_KICK_RANGE) * rel_pos_our_goal.d + WORST_DISTANCE;
        if (goal_malus < 0.0)
          goal_malus = 0.0;
      }           
    }

    global_distance = m_fBestFactor * (our_best_distance - their_best_distance) +
                      m_fMeanFactor * (our_mean_distance - their_mean_distance) -
                      goal_bonus + goal_malus;
#ifdef DEBUG
    cout << "    aktueller Winkel: " << degree << endl;
    cout << "        Our_Best_Distance:   " << our_best_distance << "    Their_Best_Distance: " << their_best_distance << endl;
    cout << "        Our_Mean_Distance:   " << our_mean_distance << "    Their_Mean_Distance: " << their_mean_distance << endl;
    cout << "        Global_Distance:     " << global_distance << endl;
#endif
    if (global_distance < global_best_distance)
    {
      global_best_distance = global_distance;
      global_best_degree = degree;
      global_best_goal_derivation = fabs (rad_in_deg (rel_pos_their_goal.richtung) - degree);
      if (goal_bonus >= WORST_DISTANCE/2.0)
        global_best_power = GOAL_KICK_POWER;
      else
        global_best_power = m_fKickPower;
    }
    else
      if (global_distance == global_best_distance)
      {
#ifdef DEBUG
        cout << fabs (rad_in_deg (rel_pos_their_goal.richtung) - degree) << endl;
        cout << global_best_goal_derivation << endl;
#endif
        if (fabs (rad_in_deg (rel_pos_their_goal.richtung) - degree) < global_best_goal_derivation)
        {
          global_best_distance = global_distance;
          global_best_degree = degree;
          global_best_goal_derivation = fabs (rad_in_deg (rel_pos_their_goal.richtung) - degree);
          if (goal_bonus >= WORST_DISTANCE/2.0)
            global_best_power = GOAL_KICK_POWER;
          else
            global_best_power = m_fKickPower;
        }     
      }
  }
  
  *bestdegree = global_best_degree;
  *bestpower = global_best_power;
#ifdef DEBUG
  cout << "    bester Winkel: " << global_best_degree << endl << endl;
#endif
  return global_best_distance;
}
