#include<string.h>
#include"weltmod.h"
#include<stream.h>
#include"referee.h"

extern Spielfeld spielfeld;
extern Weltmodell weltmodell;

const char *Sensorinformation::unser_teamname(void)
	{
	return weltmodell.frage_teamname();
	}

int Sensorinformation::linien_umrechnen(int linie)
	{
	switch(linie)
		{
		case	0:	return obere_feldlinie;
		case	1:	return untere_feldlinie;
		case	2:	return linke_feldlinie;
		case	3:	return rechte_feldlinie;
		case	4:	return undef_feldlinie;
		}

	return undef_feldlinie;
	}

int Sensorinformation::werte_linien_aus(Sensors *s,RelPos &linie_rel,int &welche_linie,
	RelPos &linie2_rel,int &welche_linie2,int &ausserhalb)
	{
	int linie = -1,linie2 = -1,anz_linien = 0;
	static const int linienindices[anzahl_linien - 1 + 1] = // mittlere Feldlinie nicht, aber anonyme Linie
		{LINE_TOP,LINE_BOTTOM,LINE_LEFT,LINE_RIGHT,LINE_ANONYMOUS};
	
	int i;
	for(i = 0;i < anzahl_linien;i++)
		{
		if(s->GetALine(linienindices[i]).IsValid())
			{
			if(anz_linien == 0) linie = i;
			else if(anz_linien == 1) linie2 = i;
			anz_linien++;
			}
		}
	if(anz_linien > 1) ausserhalb = 1;
	else ausserhalb = 0;
	
	if(anz_linien >= 1) // Falls mindestens eine Linie - 1. Linie setzen
		{
		linie_rel = s->GetALine(linienindices[linie]);
		welche_linie = linien_umrechnen(linie);
		}
	if(anz_linien >= 2) // Falls mindestens zwei Linien - auch 2. Linie setzen
		{
		linie2_rel = s->GetALine(linienindices[linie2]);
		welche_linie2 = linien_umrechnen(linie2);
		}

	return anz_linien;
	}

int Sensorinformation::flaggen_umrechnen(int flagge)
	{
	switch(flagge)
		{
		case	0:		return flagge_links_unten;
		case	1:		return flagge_links_oben;
		case	2:		return flagge_mitte_unten;
		case	3:		return flagge_mitte_oben;
		case	4:		return flagge_rechts_unten;
		case	5:		return flagge_rechts_oben;
		case	6:		return flagge_s_links_unten;
		case	7:		return flagge_s_links_mitte;
		case	8:		return flagge_s_links_oben;
		case	9:		return flagge_s_rechts_unten;
		case	10:		return flagge_s_rechts_mitte;
		case	11:		return flagge_s_rechts_oben;
		}
	return flagge_undef;
	}

int Sensorinformation::werte_flaggen_aus( Sensors *s,RelPos &flagge,int &welche_flagge)
	{
	static const int flaggenindices[anzahl_flaggen] = 
		{FLAG_LEFTBOTTOM,FLAG_LEFTTOP,FLAG_CENTERBOTTOM,FLAG_CENTERTOP,FLAG_RIGHTBOTTOM,
		FLAG_RIGHTTOP,FLAG_PENALTY_LEFTBOTTOM,FLAG_PENALTY_LEFTCENTER,FLAG_PENALTY_LEFTTOP,
		FLAG_PENALTY_RIGHTBOTTOM,FLAG_PENALTY_RIGHTCENTER,FLAG_PENALTY_RIGHTTOP};
	
	int i;
	for(i = 0;i < anzahl_flaggen;i++)
		{
		flagge = s->GetAFlag(i);
		if(flagge.IsValid()) break;
		}
	
	welche_flagge = flaggen_umrechnen(i);
	return (welche_flagge != flagge_undef); // Ob uberhaupt eine Flagge gesehen wurde
	}

int Sensorinformation::werte_punkte_aus( Sensors *s,int id[10], Relative_Koordinate delta_p[10], int
&count)
{
	static const int flaggenindices[anzahl_flaggen] = 
		{FLAG_LEFTBOTTOM,FLAG_LEFTTOP,FLAG_CENTERBOTTOM,FLAG_CENTERTOP,FLAG_RIGHTBOTTOM,
		FLAG_RIGHTTOP,FLAG_PENALTY_LEFTBOTTOM,FLAG_PENALTY_LEFTCENTER,FLAG_PENALTY_LEFTTOP,
		FLAG_PENALTY_RIGHTBOTTOM,FLAG_PENALTY_RIGHTCENTER,FLAG_PENALTY_RIGHTTOP};
	
	int i;
  RelPos punkt_rel;
 
  count=0;
  
	for(i = 0;i < anzahl_flaggen;i++){
	  punkt_rel = s->GetAFlag(i);
	  if(punkt_rel.IsValid()){
       id[count]=flaggen_umrechnen(i);
       if (id[count]==flagge_undef) continue;
       if(spielfeld.transformiere(punkt_rel,delta_p[count])){
         count++;
         if (count==10) break;
       }
     }
	}
	
  punkt_rel = s->GetRightGoal();
	if(punkt_rel.IsValid() && count<10){
		id[count]= 100+rechtes_tor;
    if(spielfeld.transformiere(punkt_rel,delta_p[count])){
      count++;		
		}
	}
 
  punkt_rel = s->GetLeftGoal();
	if(punkt_rel.IsValid() && count<10){
		id[count]= 100+linkes_tor;
    if(spielfeld.transformiere(punkt_rel,delta_p[count])){
      count++;		
		}
	} 

	return (count > 0); // Ob uberhaupt Punkte gesehen wurden
	}
  
int Sensorinformation::werte_tore_aus(Sensors *s,RelPos &tor,int &welches_tor)
	{
	tor = s->GetRightGoal();
	if(tor.IsValid())
		{
		welches_tor = rechtes_tor;
		return 1;
		}
	
	tor = s->GetLeftGoal();
	if(tor.IsValid())
		{
		welches_tor = linkes_tor;
		return 1;
		}
	
	welches_tor = undef_tor;
	return 0;
	}

int Sensorinformation::berechne_selbst(Sensors *s,Koordinate &S){
  int ausserhalb,welche_linie,welche_linie2;
  RelPos linie_rel,linie2_rel;

	int id[10], p_count, l_count, ii;
  Relative_Koordinate delta_p2[10], delta_linie1,delta_linie2;
  
  l_count=werte_linien_aus(s,linie_rel,welche_linie,linie2_rel,welche_linie2,ausserhalb);
  if( l_count==0 ){
    return 0;
  }
  else if (l_count==1){
    linie2_rel=linie_rel;
    welche_linie2=welche_linie;
  }
  if(!spielfeld.transformiere(linie_rel,delta_linie1)) return 0;
  if (l_count>1){
    if(!spielfeld.transformiere(linie2_rel,delta_linie2)) return 0;
  }
  if(werte_punkte_aus(s,id,delta_p2,p_count)){  
    spielfeld.triangulateViewPoint(spielfeld.frage_linie(welche_linie),spielfeld.frage_linie(welche_linie2),delta_linie1,delta_linie2,l_count,id,delta_p2,p_count,S);  
  }
  return 1;
}

void Sensorinformation::berechne_selbst(Sensors *s)
	{
	Koordinate S;
	
	if(!berechne_selbst(s,S)) 
	{
      selbst.setze_p (weltmodell.frage_selbst ().frage_p ());
      selbst.setze_richtung (weltmodell.frage_selbst ().frage_richtung ());
	}
	else
	{
     selbst.setze_p(S.p);
     Vektor richtung;
     richtung.x1 = cos(-S.richtung); richtung.x2 = sin(-S.richtung);
     selbst.setze_richtung(richtung);
	}
	selbst.setzen(); // selbst wird als gesetzt markiert
	}

int Sensorinformation::berechne_relative_geschwindigkeit(RelPos &r,const Vektor &pr,Geschwindigkeit &vr)
{
Vektor pr2=pr; // relative Position des Objekts nach DirChange und DistChange
		      
  if(r.GetDistance() == DIST_NOTVALID || r.GetDirChange() == DIRCHANGE_NOTVALID || 
     r.GetDistChange() == DISTCHANGE_NOTVALID) return 0;

Winkel gamma=deg_in_rad(-r.GetDirChange());
  Koerper d=r.GetDistance();
  Koerper dc=r.GetDistChange();

  if(ist_ungefaehr(d,0)) return 0;

  pr2.drehen(gamma);
  pr2=((d+dc)/d)*pr2;
  vr=-pr+pr2;
  
/*Winkel alpha = r.GetDirChange () * PI/180;
double R = pr.norm ();
Vektor E;

  E.x1 = pr.x1/R;
  E.x2 = pr.x2/R;
  vr.x1 = r.GetDistChange () * E.x1 - alpha * R * E.x2;
  vr.x2 = r.GetDistChange () * E.x2 + alpha * R * E.x1;*/
  
  return 1;
}

int Sensorinformation::berechne_relative_koordinate(RelPos &r,Vektor &p,Winkel teta)
	// Teta ist die absolute Blickrichtung des Spielers
	{
	Relative_Koordinate rk;
	
	if(!spielfeld.transformiere(r,rk)) return 0;
	
//	if(ist_ungefaehr(rk.d,0)) return 0;
	
	p.setzen(-rk.richtung - teta,rk.d);
	return 1;
	}

void Sensorinformation::berechne_ball(Sensors *s)
	{
	RelPos r = s->GetBall();
	if(!r.IsValid()) return; // Nicht gesehen
	Vektor pr;
	if(berechne_relative_koordinate(r,pr,-selbst.frage_richtung().arg()))
		{
		ball.setzen();

		ball.setze_p(pr + selbst.frage_p());
		ball.p_ist_gesetzt();
		
		Vektor vr;
		if(berechne_relative_geschwindigkeit(r,pr,vr))
			{
			ball.setze_vr(vr);
			ball.v_ist_gesetzt();
			
			}
		}
	}

void Sensorinformation::werte_nummer_und_team_aus(Player *sp,int index)
	{
	// Werte sind mit 'unsicher' vorbelegt.
	
	int nummer = sp->GetPlayerNumber();
	if(nummer != PLAYER_NUMBER_NOTVALID)
		{
		spieler[index].initialisiere_nummer(nummer - 1);
			// Umrechnen der Codes auf unser System (statt 1...11 auf 0...10)
		spieler[index].nummer_ist_gesetzt();
		}

	char *teamname = sp->GetTeamName();
	if(teamname)
		{
		if(strcmp(PLAYER_TEAM_NOTVALID,teamname)) // Falls es nicht NOTVALID ist
			{
			if(!strcmp(teamname,unser_teamname())) // Falls es unser Team ist
				spieler[index].initialisiere_team(team_wir);
			else spieler[index].initialisiere_team(team_sie);
			
			spieler[index].team_ist_gesetzt();
			}
		}
	}

void Sensorinformation::werte_position_und_geschwindigkeit_aus(Player *sp,int index)
	{
	RelPos r = *(RelPos *)sp;
	if(!r.IsValid()) return; // Nicht gesehen
	
	Vektor pr;
	if(berechne_relative_koordinate(r,pr,-selbst.frage_richtung().arg()))
		{
		spieler[index].setze_p(pr + selbst.frage_p());
		spieler[index].p_ist_gesetzt();
		
		Vektor vr;
		 if(berechne_relative_geschwindigkeit(r,pr,vr))
			{
			spieler[index].setze_vr(vr);
			spieler[index].v_ist_gesetzt();
			} 
		}
		
	}

void Sensorinformation::berechne_spieler(Player *sp)
	{
	if(!sp) return;
	if(anzahl >= max_anzahl_sensorinformation) return; // Zu viele Spieler gesehen ?
	
	werte_nummer_und_team_aus(sp,anzahl);
	werte_position_und_geschwindigkeit_aus(sp,anzahl);
	
	spieler[anzahl].setzen();
  // blockiert mich ein gegnerischer Spieler ?
  if (spieler[anzahl].frage_team()!=team_wir &&
      sp->GetDistance()<2.0 && fabs(sp->GetAngle())<85.0){
    blockingPlayerIndex=anzahl;
    //cout << sp->GetDistance() << " , " << sp->GetAngle() << " ";
  }
	anzahl++;
	}

void Sensorinformation::berechne_spieler(Sensors *s)
	{
	ALinkList <Player> *liste = s->GetPlayers();
  blockingPlayerIndex=-1;
	if(!liste) return; // Nicht sinnvoll, fortzufahren
	
	for(liste->First();!liste->OffRight();liste->Next())
		{
		Player *sp = liste->Value();
		berechne_spieler(sp);
		}
	}

Sensorinformation::Sensorinformation(Sensors *s): anzahl(0)
{ char *text;
  // Zeitpunkt der Beobachtung berucksichtigen
       
  if(s->GetMessageType() != MESSAGETYPE_SEE){ // Habe was gehoert
    if(s->GetMessageSender () == MESSAGESENDER_REFEREE){ // Schiedsrichter hat was gesagt

      weltmodell.neu_entscheiden(INFOS_GEHOERT);
      text=s->GetMessage();
    
      if(strcmp(text,"before_kick_off")==0){
	weltmodell.setze_spielzustand(BEFORE_KICK_OFF);
	if(weltmodell.frage_seite() == linke_seite) weltmodell.setze_initiative(INITIATIVE_WIR); // links faengt an 
	else weltmodell.setze_initiative(INITIATIVE_SIE);	
	weltmodell.setze_initiative(KEINE_INITIATIVE);
      }
      else if(strcmp(text,"time_over")==0){
	weltmodell.setze_spielzustand(TIME_OVER);
	weltmodell.setze_initiative(KEINE_INITIATIVE);
      }
      else if(strcmp(text,"play_on")==0){
	weltmodell.setze_spielzustand(PLAY_ON);
      if (weltmodell.frage_initiative () == INITIATIVE_WIR)
        weltmodell.entscheidung_getroffen ();
      weltmodell.setze_initiative (INITIATIVE_WIR);
      }
      else if(strcmp(text,"kick_off_l")==0){
	weltmodell.setze_spielzustand(KICK_OFF);
	if(weltmodell.frage_seite() == linke_seite) weltmodell.setze_initiative(INITIATIVE_WIR);
	else weltmodell.setze_initiative(INITIATIVE_SIE);
      }
      else if(strcmp(text,"kick_off_r")==0){
	weltmodell.setze_spielzustand(KICK_OFF);
	if(weltmodell.frage_seite() == rechte_seite) weltmodell.setze_initiative(INITIATIVE_WIR);
	else weltmodell.setze_initiative(INITIATIVE_SIE);
      }
      else if(strcmp(text,"kick_in_l")==0){
	weltmodell.setze_spielzustand(KICK_IN);
	if(weltmodell.frage_seite() == linke_seite) weltmodell.setze_initiative(INITIATIVE_WIR);
	else weltmodell.setze_initiative(INITIATIVE_SIE);
      }      
      else if(strcmp(text,"kick_in_r")==0){
	weltmodell.setze_spielzustand(KICK_IN);
	if(weltmodell.frage_seite() == rechte_seite) weltmodell.setze_initiative(INITIATIVE_WIR);
	else weltmodell.setze_initiative(INITIATIVE_SIE);
      }
      else if(strcmp(text,"free_kick_l")==0){
	weltmodell.setze_spielzustand(FREE_KICK);
	if(weltmodell.frage_seite() == linke_seite) weltmodell.setze_initiative(INITIATIVE_WIR);
	else weltmodell.setze_initiative(INITIATIVE_SIE);
      }
      else if(strcmp(text,"free_kick_r")==0){
	weltmodell.setze_spielzustand(FREE_KICK);
	if(weltmodell.frage_seite() == rechte_seite) weltmodell.setze_initiative(INITIATIVE_WIR);
	else weltmodell.setze_initiative(INITIATIVE_SIE);
      }
      else if(strcmp(text,"corner_kick_l")==0){
	weltmodell.setze_spielzustand(CORNER_KICK);
	if(weltmodell.frage_seite() == linke_seite) weltmodell.setze_initiative(INITIATIVE_WIR);
	else weltmodell.setze_initiative(INITIATIVE_SIE);
      }
      else if(strcmp(text,"corner_kick_r")==0){
	weltmodell.setze_spielzustand(CORNER_KICK);
	if(weltmodell.frage_seite() == rechte_seite) weltmodell.setze_initiative(INITIATIVE_WIR);
	else weltmodell.setze_initiative(INITIATIVE_SIE);
      }
      else if(strcmp(text,"goal_kick_l")==0){
	weltmodell.setze_spielzustand(GOAL_KICK);
	if(weltmodell.frage_seite() == linke_seite) weltmodell.setze_initiative(INITIATIVE_WIR);
	else weltmodell.setze_initiative(INITIATIVE_SIE);
      }      
      else if(strcmp(text,"goal_kick_r")==0){
	weltmodell.setze_spielzustand(GOAL_KICK);
	if(weltmodell.frage_seite() == rechte_seite) weltmodell.setze_initiative(INITIATIVE_WIR);
	else weltmodell.setze_initiative(INITIATIVE_SIE);
      }
      else if(strncmp(text,"goal_l",6)==0){
	weltmodell.setze_spielzustand(GOAL);
	if(weltmodell.frage_seite() == linke_seite) weltmodell.setze_initiative(INITIATIVE_SIE);
	else weltmodell.setze_initiative(INITIATIVE_WIR);
      }       
      else if(strncmp(text,"goal_r",6)==0){
	weltmodell.setze_spielzustand(GOAL);
	if(weltmodell.frage_seite() == rechte_seite) weltmodell.setze_initiative(INITIATIVE_SIE);
	else weltmodell.setze_initiative(INITIATIVE_WIR);
      }      
      else if(strncmp(text,"foul_l",6)==0){
	weltmodell.setze_spielzustand(FOUL);
	if(weltmodell.frage_seite() == linke_seite) weltmodell.setze_initiative(INITIATIVE_SIE); // Wir foulen doch nicht !!!
	else weltmodell.setze_initiative(INITIATIVE_WIR); 
      } 
      else if(strncmp(text,"foul_r",6)==0){
	weltmodell.setze_spielzustand(FOUL);
	if(weltmodell.frage_seite() == rechte_seite) weltmodell.setze_initiative(INITIATIVE_SIE);
	else weltmodell.setze_initiative(INITIATIVE_WIR);
      }
      else if(strcmp(text,"half_time")==0){
	weltmodell.setze_spielzustand(HALF_TIME);
	weltmodell.setze_initiative(KEINE_INITIATIVE);
      }
      else if(strcmp(text,"time_up")==0){
	weltmodell.setze_spielzustand(TIME_UP);
	weltmodell.setze_initiative(KEINE_INITIATIVE);
      }
      else if(strcmp(text,"time_up_without_a_team")==0){
	weltmodell.setze_spielzustand(TIME_UP_WITHOUT_A_TEAM);
	weltmodell.setze_initiative(KEINE_INITIATIVE);
      }
      else if(strcmp(text,"time_extended")==0){
	weltmodell.setze_spielzustand(TIME_EXTENDED);
	weltmodell.setze_initiative(KEINE_INITIATIVE);
      } 
    }
    else{  // jemand anders hat was gesagt
      return;
    }
  }
  else{  // Habe was gesehen
    zeit = s->GetTime();
    weltmodell.setze_letzte_sensor_zeit (zeit);  

    weltmodell.neu_entscheiden(INFOS_GESEHEN);
    blockingPlayerIndex=-1;
    	      
    berechne_selbst(s);

    berechne_ball(s);
		  
    berechne_spieler(s);
  }
}

void update_by_sensors(Sensors *s)
{
	if (s->GetMessageType() == MESSAGETYPE_SEE)
	{
   Zeit sensor_zeit = (Zeit)s->GetTime ();
#ifdef DEBUG
     cout << "neue Sensorzeit: " << sensor_zeit << endl;
     cout << "interne Zeit: " << Uhr::frage_jetzt () << endl;
#endif
   int count = 0;
     while (Uhr::frage_jetzt () < sensor_zeit)
     {
       Uhr::erhoehe_jetzt();
       weltmodell.frage_fruehere_situation (0)->simulieren_bis (Uhr::frage_jetzt ());
       count ++;
     }
#ifdef DEBUG
     cout << "interne Zeit nach zusaetzlicher Simulation: " << Uhr::frage_jetzt () << endl;
     cout << "Anzahl der Simulationsschritte: " << count << endl;
#endif
     Uhr::setze_jetzt(sensor_zeit);
	}
	
	weltmodell.neue_sensorinformation(s);
}

void update_by_command(cmd_struct cmd)
{
Vektor kick_richtung;
  if (weltmodell.frage_spielzustand () != PLAY_ON && (cmd.cmd == NOTHING || cmd.cmd == CHANGEVIEW))
    return;
  
  //if (Uhr::frage_jetzt () - weltmodell.frage_letzte_sensor_zeit () >= 3)
    //return;
  
  Uhr::erhoehe_jetzt();
  
  Umgebung *umgebung = weltmodell.situation[0];
  if(!umgebung)
  {
    weltmodell.neue_umgebung();
    umgebung = weltmodell.situation[0];
    if(!umgebung)
      exception("update_by_command: Fehler beim Anlegen einer neuen Umgebung");
  }
  if(cmd.status==LAST) weltmodell.neu_entscheiden(SEQUENZ_BEENDET);
  
  switch(cmd.cmd)
  {
    case	TURN:
      umgebung->selbst.drehen(deg_in_rad(cmd.farg1/(5.0 * umgebung->selbst.frage_v ().norm () + 1.0)));
      umgebung->selbst.update_stamina(globalConf->playerStaminaInc); // kein Energieverbrauch
      break;
    case	DASH:
      //umgebung->selbst.beschleunigen(cmd.farg1);
    Vektor neuer_vektor;
      neuer_vektor.setzen (umgebung->selbst.frage_richtung ().arg (), 0.01 * cmd.farg1);
      umgebung->selbst.setze_v (umgebung->selbst.frage_v () + neuer_vektor);

      umgebung->selbst.update_stamina(globalConf->playerStaminaInc - fabs(cmd.farg1));
      break;
    case KICK:
      kick_richtung=umgebung->selbst.frage_richtung();
      kick_richtung.drehen(-deg_in_rad(cmd.farg2));
      umgebung->ball.beschleunigen(cmd.farg1,kick_richtung);
      umgebung->selbst.update_stamina(globalConf->playerStaminaInc);
      break;
    default:
      umgebung->selbst.update_stamina(globalConf->playerStaminaInc);
      break;
  }
#ifdef DEBUG
  cout << "Hier wird einmal in update_by_command simuliert" << endl;
#endif
  umgebung->simulieren_bis (Uhr::frage_jetzt ());
}

































