#include<string.h>
#include<stream.h>
#include"weltmod.h"
#include"referee.h"

extern Spielfeld spielfeld;

Weltmodell weltmodell;
Zeit Uhr::jetzt = 0;

Zeit Uhr::frage_jetzt(void) {return jetzt;}

void Uhr::erhoehe_jetzt(void) {jetzt++;}

void Uhr::setze_jetzt(Zeit neu) {jetzt = neu;}

void Uhr::aktualisiere(void)
	{
	zeit = frage_jetzt();
	}

void Bewegter_Koerper::setze_v(const Geschwindigkeit &neu)
	{
	v = neu;
	}

void Bewegter_Koerper::beschleunigen(Koerper power,const Vektor &richtung)
	{
	  v += (power_rate * power) * richtung;
	  if (v.norm() > max_speed){
	    v=(max_speed/v.norm())*v;
	  }
	}

void Bewegter_Koerper::drehen(Winkel teta)
	{
	v.drehen(-teta);
	}

void Bewegter_Koerper::simulieren(int anzahl_schritte)
	{
	if(ist_unsicher()) return; // Wenn's unsicher ist, konnen wir nicht simulieren
	
	if(anzahl_schritte <= 0) return;
	
	int i;
	for(i = 0;i < anzahl_schritte;i++)
		{
		setze_p(frage_p() + v);
		v *= verlangsamung;
		erhoehen(); // Unzuverlassigkeit erhohen
		}
	
	uhr.setze_zeit(uhr.frage_zeit() + anzahl_schritte);
	}

void Bewegter_Koerper::simulieren_bis(Zeit bis)
	{
	int schritte = bis - uhr.frage_zeit();
	simulieren(schritte);
	}

/* Koerper metrik(const Bewegter_Koerper &x,const Bewegter_Koerper &y)
	{
	return norm(x.frage_p() - y.frage_p());
	}
*/

int vergleiche(const Spielerkennzeichnung &sk1,const Spielerkennzeichnung &sk2)
	{
	int team_vergleichbar = (sk1.frage_team() != team_unsicher && sk2.frage_team() != team_unsicher);
	int nummer_vergleichbar = (sk1.frage_nummer() != nummer_unsicher && sk2.frage_nummer() != nummer_unsicher);
	
	if(team_vergleichbar && sk1.frage_team() != sk2.frage_team())
		return sk_ungleich;
	
	if(nummer_vergleichbar && sk1.frage_nummer() != sk2.frage_nummer())
		return sk_ungleich;
	
	if(team_vergleichbar &&	sk1.frage_team() == sk2.frage_team() &&
		nummer_vergleichbar && sk1.frage_nummer() == sk2.frage_nummer())
		return sk_gleich;
	
	return sk_nicht_vergleichbar;
	}

void Spieler::update_stamina(float wert){
  stamina+=wert;
  if(stamina<0) stamina=0;
  if(stamina>globalConf->playerStaminaMax) stamina=globalConf->playerStaminaMax;
}

void Spieler::setze_stamina(float wert){
  stamina=wert;
  if(stamina<0) stamina=0;
  if(stamina>globalConf->playerStaminaMax) stamina=globalConf->playerStaminaMax;
}

float Spieler::frage_stamina() const {
  return stamina;
}

Spieler_Selbst::Spieler_Selbst(void)
: Spieler(weltmodell.frage_nummer(),team_wir) {richtung.x1 = 1; richtung.x2 = 0;}

void Spieler_Selbst::beschleunigen(Koerper power)
{
  Bewegter_Koerper::beschleunigen(power,richtung);
}

void Spieler_Selbst::drehen(Winkel teta)
	{
	richtung.drehen(-teta);
	richtung *= 1 / richtung.norm(); // Normieren
//	Bewegter_Koerper::drehen(teta);
	}

void Spieler_Selbst::setze_richtung(const Vektor &neu)
	{
	richtung = neu;
	setze_v(frage_v().norm() * neu);
	}


Vektor Spieler_Selbst::frage_richtung(){
  return richtung;
}

Koerper metrik(Sensor_Spieler &x,Spieler &y)
	{
	if(vergleiche((Spielerkennzeichnung &)x,(Spielerkennzeichnung &)y) ==
		sk_gleich) return 0;
	else return metrik_unendlich;
	}

void Umgebung::aktualisiere_selbst(Sensorinformation &s)
	{
	if(!s.selbst.ist_gesetzt()) return;
	selbst.setze_p(s.selbst.frage_p());
	selbst.setze_richtung(s.selbst.frage_richtung());
	selbst.initialisiere_uhr(s.zeit);
	selbst.sicher();
	}

double Umgebung::offsideLineX()
{
  if ( theOffsideLineX > 0) {
    theOffsideLineX = computeOffsideLineX();  
  }
  return theOffsideLineX;
}

double Umgebung::computeOffsideLineX()
{
  double lastPlayerX = 0.0;
  double secondLastPlayerX = 0.0;
  
  // x-Koordinaten des letzten und vorletzten gegnerischen Spielers
  // bestimmen.
  for( int i = 0; i < 11; i++) {
    if (gegner[i].frage_team()==team_sie){
      if ( gegner[i].frage_p().x1 < lastPlayerX ) {
        secondLastPlayerX = lastPlayerX;
        lastPlayerX = gegner[i].frage_p().x1;
      }
      else if ( gegner[i].frage_p().x1 < secondLastPlayerX ) {
        secondLastPlayerX = gegner[i].frage_p().x1;
      }
    }
  }
  
  return secondLastPlayerX;
}  


void Umgebung::aktualisiere_spieler(Sensorinformation &s)
	{
	int i;
	double minPosX=0;
  	
	for(i = 0;i < 21;i++)
		{
		if(!s.spieler[i].ist_gesetzt()) continue;
		
		int j,min_j_gegner;
		Spieler *minimum = 0;
		Koerper abstand_min = metrik_unendlich;
		
		for(j = 0;j < 11;j++)
			{
			Koerper abstand = metrik(s.spieler[i],gegner[j]);
			if(abstand < abstand_min)
				{
				minimum = gegner + j;
				abstand_min = abstand;
        min_j_gegner=j;
				}
			}
		
		for(j = 0;j < 10;j++)
			{
			Koerper abstand = metrik(s.spieler[i],freunde[j]);
			if(abstand < abstand_min)
				{
				minimum = freunde + j;
				abstand_min = abstand;
				}
			}
		
		// spieler[i] mit dem Minimum identifizieren
		if(!minimum) continue; // Es gibt nichts zu identifizieren
		
		if(s.spieler[i].ist_p_gesetzt()) minimum->setze_p(s.spieler[i].frage_p());
		if(s.spieler[i].ist_v_gesetzt()) minimum->setze_v(s.spieler[i].frage_vr() + selbst.frage_v());
		minimum->initialisiere_uhr(s.zeit);
		minimum->sicher();
    if (i==s.blockingPlayerIndex && minimum->frage_team()==team_sie){
      weltmodell.blockierenderGegnerIndex=min_j_gegner;
    }
		}		
  	//cout << offsideLineX() << endl;
    
    // keine blockierenden Spieler;
    if (s.blockingPlayerIndex<0){
      weltmodell.blockierenderGegnerIndex=-1;
    }    				
	}

void Umgebung::aktualisiere_ball(Sensorinformation &s)
	{
	if(!s.ball.ist_gesetzt()) return;
	if(s.ball.ist_p_gesetzt()) ball.setze_p(s.ball.frage_p());
	if(s.ball.ist_v_gesetzt()) ball.setze_v(s.ball.frage_vr() + selbst.frage_v());
	ball.initialisiere_uhr(s.zeit);
	ball.sicher();
	}

Umgebung::Umgebung(void)
	{
	selbst.initialisiere_nummer(weltmodell.frage_nummer());
	selbst.initialisiere_team(team_wir);
	
	int i;
	for(i = 0;i < 11;i++)
		{
		gegner[i].initialisiere_nummer(i);
		gegner[i].initialisiere_team(team_sie);
		}
	
	for(i = 0;i < 10;i++)
		{
		freunde[i].initialisiere_nummer(i < weltmodell.frage_nummer() ? i : i + 1);
		freunde[i].initialisiere_team(team_wir);
		}
    theOffsideLineX=1.0;
	}

void Umgebung::aktualisiere(Sensorinformation &s)
	{
/*#ifdef DEBUG
   cout << "Aktualisierung der Umgebung, interne Zeit " << Uhr::frage_jetzt () << " muesste uebereinstimmen mit" << endl;
   cout << "    Sensorzeit: " << s.zeit << endl;
#endif
	simulieren_bis(s.zeit); */
	aktualisiere_selbst(s);
	aktualisiere_spieler(s);
	aktualisiere_ball(s);
	}

void Umgebung::simulieren_bis(Zeit bis)
	{
	selbst.simulieren_bis(bis);
	ball.simulieren_bis(bis);
	
	int i;
	for(i = 0;i < 10;i++) freunde[i].simulieren_bis(bis);
	for(i = 0;i < 11;i++) gegner[i].simulieren_bis(bis);
  theOffsideLineX=1.0;
	}

Umgebung *Weltmodell::neue_umgebung(void)
	{
	Umgebung *neu = new Umgebung;
	if(!neu) exception("Weltmodell::neue_umgebung: Kein Speicher");
	if(frage_aktuelle_situation())
		*neu = *frage_aktuelle_situation();
		
	if(situation[weltmodell_tiefe - 1]) delete situation[weltmodell_tiefe - 1];
	int i;
	for(i = weltmodell_tiefe - 1;i >= 1;i--) situation[i] = situation[i - 1];
	situation[0] = neu;
  situation[0]->theOffsideLineX=1.0;
	return neu;
	}

void Weltmodell::initialisiere_seite(char neu)
	{
	if(neu != rechte_seite && neu != linke_seite) exception("Weltmodell::initialisiere_seite: unzulassiger Parameter");
	seite = neu;
	}

void Weltmodell::initialisiere_teamname(const char *neu)
	{
	if(strlen(neu) > 250) exception("Weltmodell::initialisiere_teamname: name ist zu lang.");
	strcpy(name,neu);
	}

void Weltmodell::initialisiere_nummer(int num)
	{
	if(num < 1 || num > 11) exception("Weltmodell::initialisiere_nummer: illegaler Parameter.");
	nummer = num - 1;
	}

Weltmodell::Weltmodell(void)
	{
	int i;
	for(i = 0;i < weltmodell_tiefe;i++) situation[i] = 0;
	
	m_nLetzteSensorZeit = 0;
	nummer = nummer_unsicher;
	seite = undef_seite;
	strcpy(name,"???");
        rolle=0;
        stimmung=0;
        spielzustand=BEFORE_KICK_OFF;
        initiative=KEINE_INITIATIVE;
        entscheidung=NICHTS_NEUES; // zuerst auf Infos Warten
        stammpos_spiel.x1=0;
        stammpos_spiel.x2=0;
        stammpos_anstoss.x1=0;
        stammpos_anstoss.x2=0;
        sichtbreite = VIEW_WIDTH_NORMAL;
        sichtqualitaet = VIEW_QUAL_HIGH;
        params [0] = 80.0;
        params [1] = 0.1;
        params [2] = 3.0;
        params [3] = 0.8;
        params [4] = 0.2;
        params [5] = 300.0;
  blockierenderGegnerIndex=-1;
	}

Weltmodell::~Weltmodell(void)
{
  int i;
  for(i = 0;i < weltmodell_tiefe;i++)
  if(situation[i]) delete situation[i];
}

void Weltmodell::setze_letzte_sensor_zeit (Zeit zeit)
{
  m_nLetzteSensorZeit = zeit;
}

Zeit Weltmodell::frage_letzte_sensor_zeit ()
{
  return m_nLetzteSensorZeit;
}

void Weltmodell::setze_rolle(int neue_rolle){
  rolle=neue_rolle;
}

int Weltmodell::frage_rolle(void){
  return rolle;
}

void Weltmodell::setze_stimmung(int neue_stimmung){
  stimmung=neue_stimmung;
}

int Weltmodell::frage_stimmung(void){
  return stimmung;
}

void Weltmodell::setze_stammpos_anstoss(Punkt neue_stammpos_anstoss){
  stammpos_anstoss=neue_stammpos_anstoss;
}

Punkt Weltmodell::frage_stammpos_anstoss(void){
  return stammpos_anstoss;
}

void Weltmodell::setze_stammpos_spiel(Punkt neue_stammpos_spiel){
  if (frage_seite () == linke_seite)
    stammpos_spiel = neue_stammpos_spiel;
  else
  {
    stammpos_spiel.x1 = -neue_stammpos_spiel.x1;
    stammpos_spiel.x2 = -neue_stammpos_spiel.x2;
  }
}

Punkt Weltmodell::frage_stammpos_spiel(void)
{
  return stammpos_spiel;
}

void Weltmodell::setze_stammpos_ecke (Punkt neue_stammpos_ecke)
{
  if (frage_seite () == linke_seite)
    stammpos_ecke = neue_stammpos_ecke;
  else
  {
    stammpos_spiel.x1 = -neue_stammpos_ecke.x1;
    stammpos_spiel.x2 = -neue_stammpos_ecke.x2;
  }
}

Punkt Weltmodell::frage_stammpos_ecke ()
{
  return stammpos_ecke;
}

void Weltmodell::setze_stammpos_abstoss (Punkt neue_stammpos_abstoss)
{
  if (frage_seite () == linke_seite)
    stammpos_abstoss = neue_stammpos_abstoss;
  else
  {
    stammpos_spiel.x1 = -neue_stammpos_abstoss.x1;
    stammpos_spiel.x2 = -neue_stammpos_abstoss.x2;
  }
}

Punkt Weltmodell::frage_stammpos_abstoss ()
{
  return stammpos_abstoss;
}


int Weltmodell::neue_entscheidung(void){
  return entscheidung;
}

void Weltmodell::entscheidung_getroffen(void){
  entscheidung=NICHTS_NEUES;
}

void Weltmodell::neu_entscheiden(int grund){
  entscheidung=grund;
}

void Weltmodell::setze_spielzustand(int neuer_spielzustand){
  if (spielzustand != HALF_TIME && spielzustand != TIME_UP && spielzustand != TIME_EXTENDED)
    spielzustand=neuer_spielzustand;
}

int Weltmodell:: frage_spielzustand(void){
  return spielzustand;
}

void Weltmodell::setze_initiative(int wer){
  initiative=wer;
}

int Weltmodell::frage_initiative(void){
 return initiative;
}

void Weltmodell::setze_aufstellung (int neue_aufstellung)
{
	aufstellung = neue_aufstellung;
}

int Weltmodell::frage_aufstellung ()
{
	return aufstellung;
}

void Weltmodell::neue_sensorinformation(Sensors *s)
	{
	Umgebung *neu = neue_umgebung();
	Sensorinformation sinf(s);
	neu->aktualisiere(sinf);
	}

void Weltmodell::extrapoliere(Zeit bis)
	{
	Umgebung *neu = neue_umgebung();
	neu->simulieren_bis(bis);
	}

Spieler &Weltmodell::frage_spieler(int spielernummer,int team,int zeitstufe)
	{
	if(!frage_fruehere_situation(zeitstufe)) exception("Weltmodell::frage_spieler: unzulassiger Parameter");

	if(spielernummer < 0) exception("Weltmodell::frage_spieler: unzulassige Spielernummer");
	
	if(team == team_wir)
		{
		if(spielernummer > 9) {
          exception("Weltmodell::frage_spieler: unzulassige Spielernummer");
      }
		return frage_fruehere_situation(zeitstufe)->freunde[spielernummer];
		}
	else if(team == team_sie)
		{
		if(spielernummer > 10) {
          exception("Weltmodell::frage_spieler: unzulassige Spielernummer");
      }
		return frage_fruehere_situation(zeitstufe)->gegner[spielernummer];
		}
	else exception("Weltmodell::frage_spieler: unzulassige Teamnummer");
	}

Ball &Weltmodell::frage_ball(int zeitstufe)
	{
	if(!frage_fruehere_situation(zeitstufe)) exception("Weltmodell::frage_ball: unzulassiger Parameter");
	return frage_fruehere_situation(zeitstufe)->ball;
	}

Spieler_Selbst &Weltmodell::frage_selbst(int zeitstufe)
	{
	if(!frage_fruehere_situation(zeitstufe)) exception("Weltmodell::frage_selbst: unzulassiger Parameter");
	return frage_fruehere_situation(zeitstufe)->selbst;
	}

int Weltmodell::berechne_relativ(Relative_Koordinate &delta,const Punkt &p,int zeitstufe)
	{
	if(!frage_fruehere_situation(zeitstufe)) exception("Weltmodell::berechne_relativ: unzulassiger Parameter");
	Koordinate S;
	S.p = frage_selbst(zeitstufe).frage_p();
	S.richtung = -frage_selbst(zeitstufe).frage_richtung().arg();
	return spielfeld.berechne_relative_koordinate(p,S,delta);
	}

int Weltmodell::berechne_relativ(Relative_Koordinate &delta,const Spieler_Selbst ich, const Punkt &p,int zeitstufe)
        {
        if(!frage_fruehere_situation(zeitstufe)) exception("Weltmodell::berechne_relativ: unzulassiger Parameter");
        Koordinate S;
        S.p = ich.frage_p();
        S.richtung = -ich.frage_richtung().arg();
        return spielfeld.berechne_relative_koordinate(p,S,delta);
        }

const Tor &Weltmodell::frage_ihr_tor(void) const
	{
	if(frage_seite() == linke_seite) return spielfeld.frage_tor(rechtes_tor);
	else return spielfeld.frage_tor(linkes_tor);
	}

const Tor &Weltmodell::frage_unser_tor(void) const
	{
	if(frage_seite() == rechte_seite) return spielfeld.frage_tor(rechtes_tor);
	else return spielfeld.frage_tor(linkes_tor);
	}
